/**********************************************************************
 * tcp_socket_client.c                                    November 1999
 * Horms                                             horms@vergenet.net
 *
 * Open a tcp socket to a server (we are the client)
 *
 * Released under the GNU LGPL
 *
 **********************************************************************/

#include "tcp_socket.h"


/**********************************************************************
 * tcp_socket_client_open
 * Open a socket connection as a client
 * pre: host: hostname or ipaddress to open socket to
 *      port: name or number to open
 * post: socket is opened
 * return: open socket
 *         -1 on error
 **********************************************************************/

int tcp_socket_client_open(char *host, char *port){
  int out;
  struct sockaddr_in to;
  struct hostent *hp;

  /*Get details of the forign 'to' host*/
  if((hp=gethostbyname(host)) == NULL){
    return(-1);
  }

  /*Create socket for 'to' connection*/
  if((out=socket(AF_INET, SOCK_STREAM, 0)) < 0){
    return(-1);
  }

  /*Fill in port information for 'to'*/
  bzero((struct sockaddr *)&to, sizeof(to));
  bcopy(hp->h_addr, (struct sockaddr *)&to.sin_addr, hp->h_length);
  to.sin_family = hp->h_addrtype;
  if((to.sin_port=tcp_socket_port_portno(port))==0){
    return(-1);
  }

  /*Connect to foreign 'to' server */
  if(connect(out, (struct sockaddr *)&to, sizeof(to))<0){
    return(-1);
  }

  return(out);
}
