/**********************************************************************
 * pam.c                                                     March 1999
 * Horms                                             horms@vergenet.net
 *
 * Authenticate a user using pam
 *
 * Taken fromt the pam programming guide
 *
 * Released under the terms of the GNU GPL
 *
 **********************************************************************/

#ifdef HAVE_CONFIG_H
#include "../config.h" 
#endif

#ifndef DO_PAM
#define DO_PAM

#ifdef HAVE_CONFIG_H
#include "../config.h"
#else
#define HAVE_GETOPT_LONG
#endif

#ifdef HAVE_SECURITY_PAM_MISC_H
#include <security/pam_misc.h>
#endif

#ifdef HAVE_SECURITY_PAM_APPL_H
#include <security/pam_appl.h>
#endif

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define SERVICE_NAME "perdition"
#define EX_PAM_ERROR -1


int do_pam_authentication(
  pam_handle_t *pamh,
  const char *user,
  const char *pass
);

int perdition_conv(
  int num_msg,
  struct pam_message **msgm,
  struct pam_response **response,
  void *appdata_ptr
);
int do_pam_end(pam_handle_t *pamh, int default_return);

#endif  /*DO_PAM*/
